#!/usr/bin/perl


use English;
use XML::Parser;
my  $mwbcc_domain = "";
my  $mwbcc_mailaddr = "";
my  $mwbcc_ibob = "";
my  $mwbcc_number = 0;
my  $mwdatas = "";

package Elinfo;

sub new
{
        my $class = shift;
        my $self = [0, undef, 0,0,1,{},{},{}];
}
1;

package main;

sub COUNT () {0;}
sub MINLEV () {1;}
sub SEEN   () {2;}
sub CHARS  () {3;}
sub EMPTY  () {4;}
sub PTAB   () {5;}
sub KTAB   () {6;}
sub ATAB   () {7;}
1;

my %elements;
my $seen = 0;
my $root;
my $l2;
require "/opt/nec/wbmc/lib/wbmc.pl";
my $parfi = "/etc/mail/mwbcc/mwbcc.xml";
my $subform ='      @<<<<<<<<<<<<<<<      @>>>>';

# print "Content-Type: text/html", "\n\n";


unless(-f $parfi)
{
        &showPage("./mwbccedit.cgi?error=t3");
}

my $parser = new XML::Parser(ErrorContext => 0);
eval {

$l2 = $parser->setHandlers(Start => \&start_handler,
                            Char  => \&char_handler);
$l2 = $parser->parsefile($parfi);
};
if($@) {
&showPage("./mwbccedit.cgi?error=t4");
exit(1);
}

sub start_handler
{
    my $p = shift;
    my $el = shift;

    my $elinf = $elements{$el};

    if (not defined($elinf))
    {
        $elements{$el} = $elinf = new Elinfo;
        $elinf->[SEEN] = $seen++;
    }

    $elinf->[COUNT]++;

    my $partab = $elinf->[PTAB];

    my $parent = $p->current_element;
    if (defined($parent))
    {
        $partab->{$parent}++;
        my $pinf = $elements{$parent};

        # Increment our slot in parent's child table
        $pinf->[KTAB]->{$el}++;
        $pinf->[EMPTY] = 0;
    }
    else
    {
        $root = $el;
    }

    # Deal with attributes

    my $atab = $elinf->[ATAB];

    while (@_)
    {
        my $att = shift;

        $atab->{$att}++;
        shift;  # Throw away value
    }

}  # End start_handler

sub dataset
{
        my($mailad,$domaindata,$mwibob) = @_;
        local $mwbccdataset = "$domaindata,$mailad,$mwibob\n";
#       print $mwbccdataset;
        push(@mwdatas,$mwbccdataset);
        $mwbcc_mailaddr = "";
        $mwbcc_domain = "";
        $mwbcc_ibob = "";
        }

sub data_parse
{
   my($curattr,$data) = @_;
   if($curattr eq  "domain")
   {
        $mwbcc_domain = $data;
   }elsif($curattr eq  "mailaddr")
   {
        $mwbcc_mailaddr = $data;
   }elsif($curattr eq  "direction")
   {
        $mwbcc_ibob = $data;

   }
   if ($mwbcc_mailaddr ne "" && $mwbcc_domain ne "" && $mwbcc_ibob ne  "")
  {
        &dataset($mwbcc_mailaddr,$mwbcc_domain,$mwbcc_ibob);

  }
}

sub char_handler
{
    my ($p, $data) = @_;
    my $inf = $elements{$p->current_element};
    my $infs = $p->current_element;
    $inf->[EMPTY] = 0;
    if ($data =~ /\S/)
    {
        $inf->[CHARS] += length($data);
        &data_parse($infs,$data);
#       print "$infs . $data\n";
    }
}  # End char_handler

set_minlev($root, 0);

my $el;

foreach $el (sort bystruct keys %elements)
{
    my $ref = $elements{$el};
#    print "\n================\n$el: ", $ref->[COUNT], "\n";
#    print "Had ", $ref->[CHARS], " bytes of character data\n"
#        if $ref->[CHARS];
#    print "Always empty\n"
#        if $ref->[EMPTY];

    showtab('Parents', $ref->[PTAB], 0);
    showtab('Children', $ref->[KTAB], 1);
    showtab('Attributes', $ref->[ATAB], 0);
}

sub set_minlev
{
    my ($el, $lev) = @_;

    my $elinfo = $elements{$el};
    if (! defined($elinfo->[MINLEV]) or $elinfo->[MINLEV] > $lev)
    {
        my $newlev = $lev + 1;

        $elinfo->[MINLEV] = $lev;
        foreach (keys %{$elinfo->[KTAB]})
        {
            set_minlev($_, $newlev);
        }
    }
}  # End set_minlev

sub bystruct
{
    my $refa = $elements{$a};
    my $refb = $elements{$b};

    $refa->[MINLEV] <=> $refb->[MINLEV]
        or $refa->[SEEN] <=> $refb->[SEEN];
}  # End bystruct

sub showtab
{
    my ($title, $table, $dosum) = @_;

    my @list = sort keys %{$table};

    if (@list)
    {
#        print "\n   $title:\n";

        my $item;
        my $sum = 0;
        foreach $item (@list)
        {
            my $cnt = $table->{$item};
            $sum += $cnt;
            formline($subform, $item, $cnt);
#            print $ACCUMULATOR, "\n";
            $ACCUMULATOR = '';
        }

        if ($dosum and @list > 1)
        {
#            print  "                            =====\n";
            formline($subform, '', $sum);
#            print $ACCUMULATOR, "\n";
            $ACCUMULATOR = '';
        }
    }
}
my $inner;
eval {
open(OUT,">> ./mwdata.tmp");
flock OUT,2;
truncate( OUT, 0 );
for ($inner = 0 ; $inner <=  $#mwdatas; $inner++)
{
       print OUT "$inner,$mwdatas[$inner]";
}
flock OUT,8;
close(OUT);
};
if ($@) {
&showPage("./mwbccedit.cgi?error=t5");
 }
&showPage("./mwbccedit.cgi");


