#!/bin/bash

# Copyright (C) 2002-2004 NEC Corporation
# All Rights Reserved.

# RCS: $Id: aft_alb_init_mw03.sh,v 1.1 2006/12/22 05:31:39 shodai Exp $
##20040916 v6.0.1 iANS-3.4.2 б
##                iANS ΥѥϹԤ鷺rpm Ȥƶѹ
##                ˤä kernel åץǡȻ iANS Υåץǡ
##                ߥɤ oyama

IPADDR=$1
NETMSK=$2
NETADDR=$3
BCASTADDR=$4
MODE=$5

ETHER0="eth0"
ETHER1="eth1"
ETHER0_CFG_FILE="ifcfg-eth0"
ETHER1_CFG_FILE="ifcfg-eth1"

IANS="ians"
IANS_SCPT_FILE="ans"
IANS_CFG_FILE="ians.conf"

TEAM="MAILWEB"
VIRTUAL_NAME="vad"

SOURCE_DIR="/opt/nec/wbmc/adm/system/aftalb/ians"
SCRIPT_DIR="/etc/rc.d/init.d"
#IANS_SRC_DIR="$IANS_DIR/src"
#IANS_SCPT_DIR="$IANS_DIR/install_scripts/Redhat"
IANS_CFG_DIR="/etc/ians"
NET_SCPT_DIR="/etc/sysconfig/network-scripts"

#
# STEP 1
#

# down NIC
ifconfig $ETHER0 down
ifconfig $ETHER1 down

# install IANS module
modprobe $IANS

# AFT/ALB configuration
ianscfg -a -t $TEAM -M $MODE
ianscfg -C -t $TEAM -M $MODE
ianscfg -a -t $TEAM -m $ETHER0 -p primary
ianscfg -a -t $TEAM -m $ETHER1 -p secondary
ianscfg -a -t $TEAM -v $VIRTUAL_NAME
ianscfg -c $TEAM

# check configuration
ifconfig $VIRTUAL_NAME $IPADDR netmask $NETMSK broadcast $BCASTADDRT
ianscfg -s

#
# STEP 2
#

# make directory IANS_CFG_DIR
mkdir -p $IANS_CFG_DIR

# write configuration
ianscfg -w -f $IANS_CFG_DIR/$IANS_CFG_FILE

# write /etc/ians/ians-modules.conf
cp -f $NET_SCPT_DIR/$ETHER0_CFG_FILE /opt/nec/tmp
cp -f $NET_SCPT_DIR/$ETHER1_CFG_FILE /opt/nec/tmp
/usr/sbin/iansonboot $IANS_CFG_DIR/$IANS_CFG_FILE
cp -f /opt/nec/tmp/$ETHER0_CFG_FILE $NET_SCPT_DIR
cp -f /opt/nec/tmp/$ETHER1_CFG_FILE $NET_SCPT_DIR
/sbin/ifconfig $VIRTUAL_NAME down
/sbin/modprobe -r $IANS
/sbin/modprobe $IANS

#
# STEP 3
#

# change directory to NET_SCPT_DIR
cd $NET_SCPT_DIR

# change ETHER0 and ETHER11 ONBOOT configuration
sed -e 's/ONBOOT=.*/ONBOOT=no/g' $ETHER0_CFG_FILE > $ETHER0_CFG_FILE.tmp
sed -e 's/ONBOOT=.*/ONBOOT=no/g' $ETHER1_CFG_FILE > $ETHER1_CFG_FILE.tmp
mv -f $ETHER0_CFG_FILE.tmp $ETHER0_CFG_FILE
mv -f $ETHER1_CFG_FILE.tmp $ETHER1_CFG_FILE

# make virtual adapter configuration file
echo DEVICE="$VIRTUAL_NAME" > ifcfg-"$VIRTUAL_NAME"
echo IPADDR="$IPADDR" >> ifcfg-"$VIRTUAL_NAME"
echo NETMASK="$NETMSK" >> ifcfg-"$VIRTUAL_NAME"
echo NETWORK="$NETADDR" >> ifcfg-"$VIRTUAL_NAME"
echo BROADCAST="$BCASTADDR" >> ifcfg-"$VIRTUAL_NAME"
echo ONBOOT="yes" >> ifcfg-"$VIRTUAL_NAME"
echo BOOTPROTO="none" >> ifcfg-"$VIRTUAL_NAME"

/sbin/ifup $VIRTUAL_NAME > /dev/null 2>/dev/null

